﻿using System;
using System.Collections.Generic;
using System.Text;
using WCS.BLL.DbModels.Task;

namespace WCS.Model.ApiModel.MXL4
{
    public class SysOrderMXL4Request : RequestBase
    {

        /// <summary>
        /// 按钮颜色
        /// </summary>
        public string Corlor { get; set; }

        /// <summary>
        /// 任务单号
        /// </summary>
        public string OrderNumber { get; set; }

        /// <summary>
        /// 任务类型 出库/入库/盘点
        /// </summary>
        public TaskModeEnum OrderType { get; set; }

        /// <summary>
        /// 单据明细
        /// </summary>
        public List<MXL4OrderDetail> List { get; set; }
    }

    public class MXL4OrderDetail
    {
        /// <summary>
        /// Guid系统那边任务的主键
        /// </summary>
        public Guid Guid { get; set; }

        /// <summary>
        ///系统那边的主键
        /// </summary>
        public string ItemNo { get; set; }

        /// <summary>
        /// 库位编码
        /// </summary>
        public string StoreCode { get; set; }

        /// <summary>
        /// 物料编码
        /// </summary>
        public string MatCode { get; set; } = "-";

        /// <summary>
        /// 物料名称
        /// </summary>
        public string MatName { get; set; } = "-";

        /// <summary>
        /// 物料规格
        /// </summary>
        public string MatSpec { get; set; } = "-";

        /// <summary>
        /// 物料批次
        /// </summary>
        public string MatBatch { get; set; } = "-";

        /// <summary>
        /// 物料SN
        /// </summary>
        public string MatSN { get; set; }

        /// <summary>
        /// 数量
        /// </summary>
        public int Qty { get; set; }
    }
}
